# Views S3 export

- Do you have an [RSS Feed](https://www.drupal.org/project/views_rss) built in Views and need to export it to Amazon S3?
- Do you have a View for some other data type, like CSV or XML, that should be exported periodically to Amazon S3?
- Are your dynamically generated feeds being slammed, or is access to them being throttled by your host?
- Are your MailChimp newsletters going out saying _NO RSS ITEMS FOUND_?

As long as you have access to [Drush](https://www.drush.org) and an AWS account, this module could help! Views S3 export provides a Drush command for exporting a [View](https://www.drupal.org/docs/8/core/modules/views) to a file on [Amazon S3](https://aws.amazon.com/s3/). From there, the file can be served from [CloudFront CDN](https://aws.amazon.com/cloudfront), _fast_. This is a back-end module, just containing a Drush command. If you're looking for something more user-friendly, with customisation options, batch processing, and helpful UI widgets, we recommend [Views data export](https://www.drupal.org/project/views_data_export). It's a great module!

## Features

Views S3 export aims to fill a small niche not currently served by modules like [Views data export](https://www.drupal.org/project/views_data_export): it doesn't require a Views display to export, furthermore, it doesn't require you to alter your Views at all. The code is very simple:

1. No admin UI, only Drush
2. No batching of output, only Drush\*
3. No nice buttons for users, only Drush

\* Command-line PHP usually has no timeout, so a batch process is not strictly necessary

## Post-Installation

Run the Drush command like this: `drush views:s3-export view_id display_id` There is no configuration, besides what can be passed to the Drush command. Run: `drush --help views:s3-export` For more options. Note: the command always uses the _Anonymous_ user when executing the View (please create a feature request if you have a different use-case).

### Platform.sh example

_.platform.app.yml_: `crons: newsletter: spec: '*/5 * * * *' commands: start: "cd web ; drush --uri=https://example.com --content-type='application/rss+xml' views:s3-export newsletter_feed rss_feed"` Every five minutes, this will export the View with id \`newsletter_feed\` and display id \`rss_feed\`.

## Supporting this Module

The developers of this module are available for hire at [Woolwich Web Works](https://www.woolwichweb.works). If you have budget for developing a feature you need, if you're confused by how S3 and CloudFront and Drupal fit together, or need someone besides yourself to figure it out, get in touch!
